import org.newdawn.slick.Color;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.Input;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.Sound;
import org.newdawn.slick.state.BasicGameState;
import org.newdawn.slick.state.StateBasedGame;

public class GameState extends BasicGameState {

	static int n = 10; /*numero de linhas*/
	static int m = 15; /*numero de colunas*/
	int selx, sely; /*quadrado selecionado*/
	int ax, ay; /*bixinho selecionado*/
	public casinha[][] M = new casinha[30][30]; /*matriz do tabuleiro*/
	public virus[] V = new virus[1000]; int topoV; /*array de virus*/
	public anticorpo[] A = new anticorpo[1000]; int topoA;/*array de anticorpos*/
	public celula C = new celula();/*celula*/
	Image land = null;
	Image sair = null;
	Image virusmg = null;
	Image anticorpomg = null;
	Image hemaciamg = null;
	Image bordamg = null;
	Image ganhoumg = null;
	Image perdeumg = null;
	Image botoes = null;
	Image selecionar = null;
	Image atacar = null;
	Image mover = null;
	Image encerrar = null;
	Image voltar = null;
	public int tempo;
	float largura = 42*1.2F+0.25F;
	float inix = 135;
	float iniy = 95;
	float altura = 51.38F;
	boolean player = true;
	boolean flag = false;
	boolean atacando = false;
	boolean acabou;
	boolean ganhou;
	boolean perdeu;
	boolean exit;
	boolean menu_sair;
	boolean virusCausouDano;
	boolean anticorpoCausouDano;
	int option;
	int cont;
	int ultimo;
	int PAUSA;
	int Cx, Cy; /*localizacao da celula*/
	int stateID = 0;
	casinha aux;
	java.util.Random rand = new java.util.Random ();
	Sound musica = null;

	public GameState (int stateID){
		this.stateID = stateID;
	}

	public int getID(){
		return (this.stateID);
	}


	private int abs(int i) {
		if (i < 0) i = -i;
		return i;
	}

	public void init (GameContainer gc,  StateBasedGame arg1) throws SlickException {
		for (int i = 0; i < n; i++){
			for (int j = 0; j < m; j++){
				M[i][j] = new casinha();
				M[i][j].tipo = -1;
				M[i][j].ultimo_turno = -1;
			}
		}
		exit = false;
		acabou = false;
		PAUSA = 1000000;
		cont  = 1000;
		option = -1;
		tempo = 0;
		Cx = 7; Cy = 4;
		topoA = 0; topoV = 0;
		M[Cy][Cx].tipo = 3;
		menu_sair = false;
		for (int cnt = 0; cnt < 100; cnt++){
			int x1 = abs(rand.nextInt()%(6))+5; 
			int y1 = abs(rand.nextInt()%(6))+2;
			int x2;
			int y2;

			do{
				x2 = abs(rand.nextInt()%(6))+5;
				y2 = abs(rand.nextInt()%(6))+2;
			}while(x1 == x2 || y1==y2);

			if (M[y1][x1].tipo == -1){
				M[y1][x1].tipo = 1;
				M[y1][x1].localizacao = topoV;
				V[topoV++] = new virus();
			}			
			if (M[y2][x2].tipo == -1){
				M[y2][x2].tipo = 1;
				M[y2][x2].localizacao = topoV;
				V[topoV++] = new virus();
				break;
			}
		}
		selx = 0; sely = 0;
		ganhou = perdeu = false;
		land = new Image("imagens/tabuleiro.jpeg");
		virusmg = new Image("imagens/virus2.gif");
		anticorpomg = new Image("imagens/anticorpo.gif");
		hemaciamg = new Image("imagens/hemacia2.gif");
		bordamg = new Image("imagens/borda.gif");
		sair = new Image("imagens/sair.jpeg");
		ganhoumg = new Image("imagens/ganhou.jpeg");
		perdeumg = new Image("imagens/perdeu.jpeg");
		botoes = new Image("imagens/buttons.png");
		selecionar = botoes.getSubImage(0, 0, 250, 120);
		mover = botoes.getSubImage(0, 200, 250, 120);
		atacar = botoes.getSubImage(0, 400, 250, 120);
		encerrar = botoes.getSubImage(0, 600, 250, 120);
		voltar = botoes.getSubImage(0, 0, 800, 120);
	}


	public void update (GameContainer gc,  StateBasedGame sb, int delta) {

		if (exit){
			exit = false;
			menu_sair = false;
			sb.enterState(StateManager.MAINMENUSTATE);
		}
		/*vez do jogador*/
		if (player&true){
			turnoJogador(gc, sb, delta);
		}
		/*vez do pc*/
		else{
			turnoPC();
			player = true;
			tempo++;
		}

	}

	public void render (GameContainer gc, StateBasedGame sb, Graphics g) {

		land.draw (0, 0);


		for (int i = 0; i < n; i++){
			for (int j = 0; j < m; j++){
				if (M[i][j].tipo == 1){
					virusmg.draw(j*largura+inix, i*altura+iniy);
				}
				if (M[i][j].tipo == 2){
					anticorpomg.draw(j*largura+inix, i*altura+iniy);
				}
				if (M[i][j].tipo == 3){
					hemaciamg.draw(j*largura+inix, i*altura+iniy);
				}
			}
		}

		bordamg.draw (selx*largura+inix-2.F, sely*altura+iniy-2.F);

		if (perdeu){
			g.drawString("Grau da infeco: Curada", 130, 30);
			perdeumg.draw (240, 180);

		}
		if (menu_sair){
			sair.draw (200,200);
		}
		if (ganhou){
			ganhoumg.draw (240, 180);
		}

		Color color = new Color(0, 0, 0);
		g.setColor(color);

		if(C.vida >= 40)
			g.drawString("Grau da infeco: Aguda", 130, 30);
		else if (C.vida >= 20)
			g.drawString("Grau da infeco: Mdia", 130, 30);
		else if (C.vida >= 10)
			g.drawString("Grau da infeco: Leve", 130, 30);
		else if (C.vida > 0)
			g.drawString("Grau da infeco: Quase curada", 130, 30);

		g.drawString("Turno: "+tempo/2, 500,30);
		botoes.draw(10, 640);
	}

	private void turnoJogador (GameContainer gc,  StateBasedGame sb, int delta){
		/*vez do jogador*/

		Input input = gc.getInput();

		if (acabou && cont > 500) {
			sb.enterState(StateManager.MAINMENUSTATE);
		}

		option = achaMouse(input);

		if(acabou == false && cont > 100){
			if(input.isKeyDown(Input.KEY_RIGHT)){
				if (selx == m-1) selx = 0;
				else selx++;
			}
			if(input.isKeyDown(Input.KEY_LEFT)){
				if (selx == 0) selx = m-1;
				else selx--;
			}
			if(input.isKeyDown(Input.KEY_DOWN)){
				if (sely == n-1) sely = 0;
				else sely++;
			}
			if(input.isKeyDown(Input.KEY_UP)){
				if (sely == 0) sely = n-1;
				else sely --;
			}
			/*selecionar*/
			if(input.isKeyDown(Input.KEY_S) || 
					(input.isMouseButtonDown(Input.MOUSE_LEFT_BUTTON) && option == 0)){
				if (M[sely][selx].tipo == 1){
					atacando = true;
					ax = selx; ay = sely;
				}
			}
			/*mover*/
			if(input.isKeyDown(Input.KEY_M) || 
					(input.isMouseButtonDown(Input.MOUSE_LEFT_BUTTON) && option == 1)){
				if (M[sely][selx].tipo == -1 && (abs(sely-ay) + abs(selx-ax)) == 1 && M[ay][ax].ultimo_turno != tempo){
					aux = M[sely][selx];
					M[sely][selx] = M[ay][ax];
					M[ay][ax] = aux;
					M[sely][selx].ultimo_turno = tempo;
				}
			}
			/*efetuar ataque*/
			if(input.isKeyDown(Input.KEY_A)  || 
					(input.isMouseButtonDown(Input.MOUSE_LEFT_BUTTON) && option == 2)){
				if (M[sely][selx].tipo == 2 && (abs(sely-ay) + abs(selx-ax)) == 1){
					V[M[ay][ax].localizacao].atacar (A[M[sely][selx].localizacao], M, selx, sely, ax, ay);
					virusCausouDano = true;
				}

			}
			/*Encerra rodada*/
			if(input.isKeyDown(Input.KEY_F) || 
					(input.isMouseButtonDown(Input.MOUSE_LEFT_BUTTON) && option == 3)){
				tempo++; 
				player = false;
			}
			if(input.isKeyDown(Input.KEY_ESCAPE) || 
					(input.isMouseButtonDown(Input.MOUSE_LEFT_BUTTON) && option == 4)){
				menu_sair = true;
			}
			if(input.isKeyDown(Input.KEY_Y)){
				exit = true;
			}
			if(input.isKeyDown(Input.KEY_N)){
				menu_sair = false;
			}
			cont = 0;
		}
		else{
			cont = cont+delta;
		}

		option = -1;
	}

	private void turnoPC(){
		int p= 0;
		if (tempo < 16)
			p = 5;
		if (16 <= tempo && tempo < 30)
			p = 3;
		if ( 30<= tempo && tempo < 35)
			p = 2;
		if (tempo >= 35)
			p = 1;
		/*cria novo anticorpo*/
		if (tempo%p == 0){
			while (true){
				int qual =  abs(rand.nextInt()%2);
				if (qual == 0){
					int i = rand.nextInt();
					i %= n; i = abs(i);
					if (M[i][0].tipo == -1){
						M[i][0].tipo = 2; M[i][0].localizacao = topoA;
						A[topoA++] = new anticorpo();
						A[M[i][0].localizacao].ultimo_turno = tempo;
						break;
					}
				}
				else {
					int i = rand.nextInt();
					i %= n; i = abs(i);
					if (M[i][m-1].tipo == -1){
						M[i][m-1].tipo = 2; M[i][m-1].localizacao = topoA;
						A[topoA++] = new anticorpo();
						A[M[i][m-1].localizacao].ultimo_turno = tempo;
						break;
					}
				}
			}
		}
		for (int i = n-1; i >= 0; i--){
			for (int j = m-1; j >= 0; j--){
				if (M[i][j].tipo == 2 && A[M[i][j].localizacao].ultimo_turno != tempo){
					A[M[i][j].localizacao].ultimo_turno = tempo;
					A[M[i][j].localizacao].interage(M, j, i, V, Cx, Cy, C);
				}
			}
		}

		if (C.vida <= 0){
			perdeu = true;
			acabou = true;
		}
		/* Gera um virus novo proximo a celula infectada
		 * a cada tres rodadas */
		if (tempo%3 == 0){
			for (int cnt = 0; cnt < 100; cnt++){
				int x = abs(rand.nextInt()%(6))+5; 
				int y = abs(rand.nextInt()%(6))+2;
				if (M[y][x].tipo == -1){
					M[y][x].tipo = 1;
					M[y][x].localizacao = topoV;
					V[topoV++] = new virus();
					break;
				}
			}
		}
	}
	private int achaMouse(Input input){
		int mouseX = input.getMouseX();
		int mouseY = input.getMouseY();
		int menux = 10;
		int menuy = 640;
		int buttonw = 200;
		int buttonh = 120;

		if( ( mouseX >= menux && mouseX <= menux + buttonw) &&
				( mouseY >= menuy && mouseY <= menuy + buttonh) ){
			return 0;
		}
		if( ( mouseX >= menux + buttonw && mouseX <= menux + 2*buttonw) &&
				( mouseY >= menuy && mouseY <= menuy + buttonh) ){
			return 1;
		}
		if( ( mouseX >= menux + 2*buttonw && mouseX <= menux + 3*buttonw) &&
				( mouseY >= menuy && mouseY <= menuy + buttonh) ){
			return 2;
		}
		if( ( mouseX >= menux + 3*buttonw && mouseX <= menux + 4*buttonw) &&
				( mouseY >= menuy && mouseY <= menuy + buttonh) ){
			return 3;
		}
		if( ( mouseX >= menux + 4*buttonw && mouseX <= menux + 5*buttonw) &&
				( mouseY >= menuy && mouseY <= menuy + buttonh) ){
			return 4;
		}

		return -1;
	}
}
