import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.Input;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.state.BasicGameState;
import org.newdawn.slick.state.StateBasedGame;


public class InfoState extends BasicGameState {
	private int stateID = 3;
	private int tempo = 0;
	
	Image bg = null;
	Image button = null;
	
	float scale = 1;
	float scaleStep = 0.0001f;
	
	public InfoState (int ID){
		this.stateID = ID;
	}

	public int getID() {
		return this.stateID;
	}

	@Override
	public void init(GameContainer arg0, StateBasedGame arg1)
			throws SlickException {
		if (this.getID() == 3)
			bg = new Image("imagens/obj.jpeg");
		if(this.getID() == 4)
			bg = new Image("imagens/turno.jpeg");
		if(this.getID() == 5)
			bg = new Image("imagens/atack.jpeg");
		if(this.getID() == 6)
			bg = new Image("imagens/move.jpeg");
		if(this.getID() == 7)
			bg = new Image("imagens/creditos.jpeg");
		button = new Image("imagens/voltar.jpg");
	}

	@Override
	public void render(GameContainer arg0, StateBasedGame arg1, Graphics arg2)
			throws SlickException {
		bg.draw(0, 0);
		button.draw(750, 50);
		
	}

	@Override
	public void update(GameContainer gc, StateBasedGame sb, int delta)
			throws SlickException {
		
		Input input = gc.getInput();

		int mouseX = input.getMouseX();
		int mouseY = input.getMouseY();
		
		if( ( mouseX >= 750 && mouseX <= 990) &&
				( mouseY >= 50 && mouseY <= 130) && tempo > 100){
				if(scale < 1.05f){
					scale += scaleStep * delta;
				}
				if ( input.isMouseButtonDown(Input.MOUSE_LEFT_BUTTON) || input.isKeyDown(Input.KEY_ENTER) ){
					if(getID() != 7)
						sb.enterState(StateManager.INSTRUCTIONSSTATE);
					else
						sb.enterState(StateManager.MAINMENUSTATE);
			}
		}else {
				if(scale > 1.0f)
					scale -= scaleStep * delta;		
		}
		
		tempo = tempo + delta;
		
	}


}
