import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.Input;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.state.BasicGameState;
import org.newdawn.slick.state.StateBasedGame;


public class InstructionsState extends BasicGameState {
	private int stateID = 2;
	
	private Image bg= null;
	private Image turno = null;
	private Image objetivos = null;
	private Image mover = null;
	private Image atacar = null;
	private Image sair = null;
	
	float turnos = 1;
	float objetivoss = 1;
	float movers = 1;
	float atacars = 1;
	float sairs = 1;
	float scaleStep = 0.0001f;
	float tempo;
	
	private int menux = 320;
	private int menuy = 290;
	private int buttonh = 65;
	private int buttonw = 345;
	private int dist = 25;
	private int option = 0;
	
	
	private boolean [] selectedOption = new boolean [5];

	
	public InstructionsState (int stateID){
		this.stateID = stateID;
	}
	
	public int getID (){
		return this.stateID;
	}
	
	private int abs(int i) {
		if (i < 0) i = -i;
		return i;
	}

	@Override
	public void init(GameContainer arg0, StateBasedGame arg1)
			throws SlickException {
		bg = new Image("imagens/instrucoes.jpeg");
		
		atacar = new Image("imagens/atacari.jpeg");
		mover = new Image("imagens/moveri.jpeg");
		turno = new Image("imagens/turnoi.jpeg");
		objetivos = new Image("imagens/objetivosi.jpeg");
		sair = new Image("imagens/sairb.jpeg");
		
		option = -1;
		
		
		tempo = 1000;
	}


	@Override
	public void update(GameContainer gc, StateBasedGame sb, int delta)
			throws SlickException {
		
		
		Input input = gc.getInput();


		int mouseX = input.getMouseX();
		int mouseY = input.getMouseY();
				

		if( ( mouseX >= menux && mouseX <= menux + buttonw) &&
				( mouseY >= menuy && mouseY <= menuy + buttonh) ){
			option = 0;
		}
		if( ( mouseX >= menux && mouseX <= menux + buttonw) &&
				( mouseY >= menuy+ dist+ buttonh && mouseY <= menuy+dist+2*buttonh) ){
			option = 1;
		}
		if( ( mouseX >= menux && mouseX <= menux + buttonw) &&
				( mouseY >= menuy+ 2*(dist+buttonh) && mouseY <= menuy+2*dist+3*buttonh) ){
			option = 2;
		}
		if( ( mouseX >= menux && mouseX <= menux + buttonw) &&
				( mouseY >= menuy+ 3*(dist+buttonh) && mouseY <= menuy+3*dist+4*buttonh) ){
			option = 3;
		}
		if( ( mouseX >= menux && mouseX <= menux + buttonw) &&
				( mouseY >= menuy+ 4*(dist+buttonh) && mouseY <= menuy+4*dist+5*buttonh) ){
			option = 4;
		}		

		if(tempo > 100){
			if(input.isKeyDown(Input.KEY_DOWN)){
				option = (option + 1) %5;
			}

			if(input.isKeyDown(Input.KEY_UP)){
				option = abs((option - 1)) %5;
			}
			tempo = 0;
		}
		
		tempo = tempo + delta;
		
		for(int i = 0; i < 5; i++){
			if(i == option)
				selectedOption [i] = true;
			else
				selectedOption [i] = false;
		}

		
		if(selectedOption [0]){
			if(objetivoss < 1.05f){
				objetivoss += scaleStep * delta;
			}
			if ( input.isMouseButtonDown(Input.MOUSE_LEFT_BUTTON) || input.isKeyDown(Input.KEY_ENTER) ){
				sb.enterState(StateManager.INSTRUCTIONSSTATE1);
			}

		}else {
			if(objetivoss > 1.0f)
				objetivoss -= scaleStep * delta;		
		}

		if(selectedOption [2]){
			if(atacars < 1.05f){
				atacars += scaleStep * delta;
			}
			if ( input.isMouseButtonDown(Input.MOUSE_LEFT_BUTTON) || input.isKeyDown(Input.KEY_ENTER)){
				sb.enterState(StateManager.INSTRUCTIONSSTATE3);
			}

		}else {
			if(atacars > 1.0f)
				atacars -= scaleStep * delta;		
		}
		
		if(selectedOption [3]){
			if(movers < 1.05f){
				movers += scaleStep * delta;
			}
			if ( input.isMouseButtonDown(Input.MOUSE_LEFT_BUTTON) || input.isKeyDown(Input.KEY_ENTER)){
				sb.enterState(StateManager.INSTRUCTIONSSTATE4);
			}

		}else {
			if(movers > 1.0f)
				movers -= scaleStep * delta;		
		}

		if(selectedOption [4]){
			if(sairs < 1.05f){
				sairs +=  scaleStep * delta;
			}
			if ( input.isMouseButtonDown(Input.MOUSE_LEFT_BUTTON) || input.isKeyDown(Input.KEY_ENTER))
				sb.enterState(StateManager.MAINMENUSTATE);
		}
		else{
			if(sairs > 1.0f)
				sairs -= scaleStep * delta;
		}

		if(selectedOption [1]){
			if(turnos < 1.05f){
				turnos += scaleStep * delta;
			}
			if ( input.isMouseButtonDown(Input.MOUSE_LEFT_BUTTON) || input.isKeyDown(Input.KEY_ENTER)){
				sb.enterState(StateManager.INSTRUCTIONSSTATE2);
			}

		}else {
			if(turnos > 1.0f)
				turnos -= scaleStep * delta;		
		}
		
	}

	public void render(GameContainer arg0, StateBasedGame arg1, Graphics arg2)
			throws SlickException {

		bg.draw (0, 0);
		
		objetivos.draw(menux, menuy, objetivoss);
		turno.draw(menux, menuy+dist+buttonh, turnos);
		atacar.draw(menux, menuy+2*(dist+buttonh), atacars);
		mover.draw(menux, menuy+3*(dist+buttonh), movers);
		sair.draw(menux, menuy+4*(dist+buttonh), sairs);
		
	}
	
	
}
