import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.Input;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.Sound;
import org.newdawn.slick.state.BasicGameState;
import org.newdawn.slick.state.StateBasedGame;


public class MenuState extends BasicGameState {
	private int stateID = 0;
	
	private Image menu = null;
	private Image comecar = null;
	private Image instrucoes = null;
	private Image creditos = null;
	private Image sair = null;
	
	float comecars = 1;
	float instrucoess = 1;
	float creditoss = 1;
	float sairs = 1;
	float scaleStep = 0.0001f;
	float tempo;
	
	private int menux = 320;
	private int menuy = 375;
	private int buttonh = 65;
	private int buttonw = 345;
	private int dist = 25;
	private int option = 0;
	
	private Sound music = null;
	
	private boolean [] selectedOption = new boolean [4];

	
	public MenuState (int stateID){
		this.stateID = stateID;
	}
	
	public int getID (){
		return this.stateID;
	}
	
	private int abs(int i) {
		if (i < 0) i = -i;
		return i;
	}

	@Override
	public void init(GameContainer arg0, StateBasedGame arg1)
			throws SlickException {
		menu = new Image("imagens/menu1.jpeg");
		
		comecar = new Image("imagens/comecar.jpeg");
		creditos = new Image("imagens/credito.jpeg");
		instrucoes = new Image("imagens/instrucao.jpeg");
		sair = new Image("imagens/sairb.jpeg");
		music = new Sound("resources/sons/alienblues.wav");

		//music.loop();
		
		tempo = 1000;
	}


	@Override
	public void update(GameContainer gc, StateBasedGame sb, int delta)
			throws SlickException {
		
		Input input = gc.getInput();


		int mouseX = input.getMouseX();
		int mouseY = input.getMouseY();
				
		achaMouse(mouseX, mouseY);
		processaMouse (delta, input, sb, gc);		
	}
	
	private void achaMouse(int mouseX, int mouseY){
		if( ( mouseX >= menux && mouseX <= menux + buttonw) &&
				( mouseY >= menuy && mouseY <= menuy + buttonh) ){
			option = 0;
		}
		if( ( mouseX >= menux && mouseX <= menux + buttonw) &&
				( mouseY >= menuy+ dist+ buttonh && mouseY <= menuy+dist+2*buttonh) ){
			option = 1;
		}
		if( ( mouseX >= menux && mouseX <= menux + buttonw) &&
				( mouseY >= menuy+ 2*(dist+buttonh) && mouseY <= menuy+2*dist+3*buttonh) ){
			option = 2;
		}
		if( ( mouseX >= menux && mouseX <= menux + buttonw) &&
				( mouseY >= menuy+ 3*(dist+buttonh) && mouseY <= menuy+3*dist+4*buttonh) ){
			option = 3;
		}
	}

	private void processaMouse (int delta, Input input, StateBasedGame sb, GameContainer gc){
		if(tempo > 100){
			if(input.isKeyDown(Input.KEY_DOWN)){
				option = (option + 1) %4;
			}

			if(input.isKeyDown(Input.KEY_UP)){
				option = abs((option - 1)) %4;
			}
			tempo = 0;
		}
		
		tempo = tempo + delta;
		
		for(int i = 0; i < 4; i++){
			if(i == option)
				selectedOption [i] = true;
			else
				selectedOption [i] = false;
		}

		
		if(selectedOption [0]){
			if(comecars < 1.05f){
				comecars += scaleStep * delta;
			}
			if ( input.isMouseButtonDown(Input.MOUSE_LEFT_BUTTON) || input.isKeyDown(Input.KEY_ENTER) ){
				music.stop();
				sb.enterState(StateManager.GAMEPLAYSTATE);
			}

		}else {
			if(comecars > 1.0f)
				comecars -= scaleStep * delta;		
		}
		if(selectedOption [2]){
			if(instrucoess < 1.05f){
				instrucoess += scaleStep * delta;
			}
			if ( input.isMouseButtonDown(Input.MOUSE_LEFT_BUTTON) || input.isKeyDown(Input.KEY_ENTER)){
				sb.enterState(StateManager.INSTRUCTIONSSTATE);
			}

		}else {
			if(instrucoess > 1.0f)
				instrucoess -= scaleStep * delta;		
		}
		
		if(selectedOption [1]){
			if(creditoss < 1.05f){
				creditoss += scaleStep * delta;
			}
			if ( input.isMouseButtonDown(Input.MOUSE_LEFT_BUTTON) || input.isKeyDown(Input.KEY_ENTER)){
				music.stop();
				sb.enterState(StateManager.CREDITSSTATE);
			}

		}else {
			if(creditoss > 1.0f)
				creditoss -= scaleStep * delta;		
		}

		if(selectedOption [3]){
			if(sairs < 1.05f){
				sairs +=  scaleStep * delta;
			}
			if ( input.isMouseButtonDown(Input.MOUSE_LEFT_BUTTON) || input.isKeyDown(Input.KEY_ENTER))
				gc.exit();
		}
		else{
			if(sairs > 1.0f)
				sairs -= scaleStep * delta;
		}
		
	}
	
	public void render(GameContainer arg0, StateBasedGame arg1, Graphics arg2)
			throws SlickException {

		menu.draw (0, 0);
		
		comecar.draw(menux, menuy, comecars);
		creditos.draw(menux, menuy+dist+buttonh, creditoss);
		instrucoes.draw(menux, menuy+2*(dist+buttonh), instrucoess);
		sair.draw(menux, menuy+3*(dist+buttonh), sairs);
		
	}
	
	
}
