import org.newdawn.slick.AppGameContainer;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.state.StateBasedGame;


public class StateManager extends StateBasedGame {
 
    public static final int MAINMENUSTATE          = 0;
    public static final int GAMEPLAYSTATE          = 1;
    public static final int INSTRUCTIONSSTATE      = 2;
    public static final int INSTRUCTIONSSTATE1     = 3;
    public static final int INSTRUCTIONSSTATE2     = 4;
    public static final int INSTRUCTIONSSTATE3     = 5;
    public static final int INSTRUCTIONSSTATE4     = 6;
    public static final int CREDITSSTATE           = 7;
 
    public StateManager() {
        super("VirusProject");
  
        this.addState(new MenuState(MAINMENUSTATE));
        this.addState(new GameState(GAMEPLAYSTATE));
        this.addState(new InstructionsState(INSTRUCTIONSSTATE));
        this.addState(new InfoState(INSTRUCTIONSSTATE1));
        this.addState(new InfoState(INSTRUCTIONSSTATE2));
        this.addState(new InfoState(INSTRUCTIONSSTATE3));
        this.addState(new InfoState(INSTRUCTIONSSTATE4));
        this.addState(new InfoState(CREDITSSTATE));
        this.enterState(MAINMENUSTATE);
    }
 
    public static void main(String[] args) throws SlickException
    {
         AppGameContainer app = new AppGameContainer(new StateManager());
 
         app.setDisplayMode(1024, 768, false);
         app.start();
    }
 
    @Override
    public void initStatesList(GameContainer gameContainer) throws SlickException {
 
        this.getState(MAINMENUSTATE).init(gameContainer, this);
        this.getState(INSTRUCTIONSSTATE).init(gameContainer, this);
        this.getState(INSTRUCTIONSSTATE1).init(gameContainer, this);
        this.getState(INSTRUCTIONSSTATE2).init(gameContainer, this);
        this.getState(INSTRUCTIONSSTATE3).init(gameContainer, this);
        this.getState(INSTRUCTIONSSTATE4).init(gameContainer, this);
        this.getState(CREDITSSTATE).init(gameContainer, this);
        this.getState(GAMEPLAYSTATE).init(gameContainer, this);
        
 
        //tentar criar um novo state
 
    }
 
}